import java.io.*;
import java.net.*;
import java.util.*;

class ChatServer {

	public static void main(String[] args) {
		int i = 1;
		Vector klienter = new Vector(50);
		
		try {
			// Dispatcher thread
			ServerSocket s = new ServerSocket(7913);
			while (true) {
  			Socket incoming = s.accept(); // vent p klient
	  		// Her er en klient get i flden
	  		klienter.add(incoming);
	  		
	  		System.out.println("Spawning thread " + i);
	  		// Her startes en worker thread
	  		new Handler(incoming, i, klienter).start();
	  		i++;
			}
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
}

class Handler extends Thread {
	
	private Socket incoming;
	private int counter;
	private Vector klienter;
	
	public Handler(Socket s, int i, Vector k) {
		incoming = s;
		counter = i;
		klienter = k;
	}
	
	public void run() {
		try {
			DataInputStream in = new 
			  DataInputStream(incoming.getInputStream());
			PrintStream out = new PrintStream(incoming.getOutputStream());
			out.println("Velkommen til Chat serveren.");
			out.println("Tast FARVEL for at stoppe.");
			
			boolean done = false;
			while (!done) {
				String str = in.readLine();
				if (str == null)
					done = true;
				else {
					// Rundsend til alle klienter
					for (int i = 0; i < klienter.size(); i++) {
						Socket v = (Socket) klienter.get(i);
						PrintStream vout = new PrintStream(v.getOutputStream());
						vout.println("<" + counter + "> " + str);
					}

					if (str.trim().equals("FARVEL"))
						done = true;
					}
				}
			// Her termineres worker thread
			incoming.close();
			klienter.remove(incoming);
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
}